=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2010-09-17 15:15:34 +0000
+++ bzrlib/status.py	2010-10-18 21:34:05 +0000
@@ -444,7 +444,10 @@
 
     :param params: StatusHookParams.
     """
-    manager = params.new_tree.get_shelf_manager()
+    get_shelf_manager = getattr(params.new_tree, 'get_shelf_manager', None)
+    if get_shelf_manager is None:
+        return
+    manager = get_shelf_manager()
     shelves = manager.active_shelves()
     if shelves:
         params.to_file.write('%d shelves exist. '

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2010-09-12 05:09:24 +0000
+++ bzrlib/tests/blackbox/test_status.py	2010-10-18 21:34:05 +0000
@@ -45,6 +45,14 @@
 
 class BranchStatus(TestCaseWithTransport):
 
+    def setUp(self):
+        super(BranchStatus, self).setUp()
+        # As TestCase.setUp clears all hooks, we install this default
+        # post_status hook handler for the test.
+        status.hooks.install_named_hook('post_status',
+            status._show_shelve_summary,
+            'bzr status')
+
     def assertStatus(self, expected_lines, working_tree,
         revision=None, short=False, pending=True, verbose=False):
         """Run status in working_tree and look for output.
@@ -530,11 +538,6 @@
         self.run_bzr(['shelve', '--all', '-m', 'foo'])
         self.build_tree(['bye.c'])
         wt.add('bye.c')
-        # As TestCase.setUp clears all hooks, we install this default
-        # post_status hook handler for the test.
-        status.hooks.install_named_hook('post_status',
-            status._show_shelve_summary,
-            'bzr status')
         self.assertStatus([
                 'added:\n',
                 '  bye.c\n',

=== modified file 'doc/en/release-notes/bzr-2.3.txt'
--- doc/en/release-notes/bzr-2.3.txt	2010-10-18 12:36:03 +0000
+++ doc/en/release-notes/bzr-2.3.txt	2010-10-18 21:34:05 +0000
@@ -46,6 +46,9 @@
 
 * Always set PATH in start_bzr.bat on Windows. (Matthäus G. Chajdas, #470264)
 
+* ``bzr status -r X..Y`` was failing because RevisionTree didn't implement
+  ``get_shelf_manager``. (John Arbash Meinel, #662053)
+
 * Don't force openssh to use protocol=2, since that is now the default.
   (Neil Martinsen-Burrell, #561061)
 

